program test;

{$mode objfpc}{$H+}

uses
  FPJSON, JSONParser, Classes, SysUtils;

var
  S: string;
  VFileName: TFileName;
  VCreateJSONFile: Boolean;
  VJSONObject: TJSONObject;
  VJSONParser: TJSONParser;
  VMemoryStream: TMemoryStream;
begin
  VFileName := ExtractFilePath(ParamStr(0)) + 'test.json';
  VMemoryStream := TMemoryStream.Create;
  if FileExists(VFileName) then
    VMemoryStream.LoadFromFile(VFileName);
  VJSONParser := TJSONParser.Create(VMemoryStream);
  try
    VJSONObject := TJSONObject(VJSONParser.Parse);
    VCreateJSONFile := not Assigned(VJSONObject);
    if VCreateJSONFile then
    begin
      VJSONObject := TJSONObject.Create([]);
      VJSONObject.Add('Value_1', 'ABC');
      VJSONObject.Add('Value_2', True);
      VJSONObject.Add('Value_3', 123);
    end
    else
    begin
      VJSONObject['Value_1'].AsString := 'DEF';
      VJSONObject['Value_2'].AsBoolean := False;
      VJSONObject['Value_3'].AsInteger := 456;
    end;
    VMemoryStream.Clear;
    S := VJSONObject.AsJSON;
    VMemoryStream.Write(Pointer(S)^, Length(S));
    VMemoryStream.SaveToFile(VFileName);
  finally
    FreeAndNil(VJSONObject);
    VJSONParser.Free;
    VMemoryStream.Free;
  end;
end.

